﻿Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices

Module mmgic3f

    '//
    '//// mmgic3f.dll Header Ver3.1a
    '//
    '///  (C) m.magic & K Maruyama.  All rights reserved.

    '//
    '//// 共通
    '//

    '// 定数
    Public Const MF_OK As Integer = 1
    Public Const MF_CANCEL As Integer = 2
    Public Const MF_TRUE As Integer = 1
    Public Const MF_FALSE As Integer = 0
    Public Const MF_NULL As Integer = 0
    Public Const MF_MAX_PATH As Integer = 259
    Public Const MF_IDOK As Integer = 1
    Public Const MF_IDCANCEL As Integer = 2

    Public Const MF_SUCCESS As Integer = 0  '//成功
    Public Const MF_FAILURE As Integer = -1 '//失敗

    Public Const MF_ID_SIZE As Integer = 259
    Public Const MF_SUBID_SIZE As Integer = 63
    Public Const MF_TIME_SIZE As Integer = 15
    Public Const MF_KEY_SIZE_32 As Integer = 32
    Public Const MF_KEY_SIZE_20 As Integer = 20
    Public Const MF_VALCODE_SIZE As Integer = 31

    Public Const MF_18 As Integer = 18   '// キー１８文字
    Public Const MF_24 As Integer = 24   '// キー２４文字
    Public Const MF_32 As Integer = 32   '// キー３２文字

    '// プロダクトキーバッファサイズ
    Public Const MF_ID_BUFF18 As Integer = 18  '// 18桁
    Public Const MF_ID_BUFF24 As Integer = 24  '// 24桁
    Public Const MF_ID_BUFF32 As Integer = 32  '// 32桁

    Public Structure MF_IDENTITY_KV13
        Dim nID As Integer
        <VBFixedArray(MF_SUBID_SIZE), MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
        Dim nSubID() As Integer
        Public Sub Initialize()
            ReDim nSubID(MF_SUBID_SIZE)
        End Sub
    End Structure

    Public Structure MF_IDENTITY_KV17
        <VBFixedArray(MF_ID_SIZE), MarshalAs(UnmanagedType.ByValArray, SizeConst:=260)> _
        Dim szID() As Byte
        Public Sub Initialize()
            ReDim szID(MF_ID_SIZE)
        End Sub
    End Structure

    Public Structure MF_TIME
        <VBFixedArray(MF_TIME_SIZE), MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Dim szTime1() As Byte
        <VBFixedArray(MF_TIME_SIZE), MarshalAs(UnmanagedType.ByValArray, SizeConst:=16)> _
        Dim szTime2() As Byte
        Public Sub Initialize()
            ReDim szTime1(MF_TIME_SIZE)
            ReDim szTime2(MF_TIME_SIZE)
        End Sub
    End Structure

    '//* mfInitialize *//
    '// キーバージョン設定
    Public Const MF_KEY_VERSION_13 As Integer = 13 '// Ver1.3 以前のスタイル
    Public Const MF_KEY_VERSION_14 As Integer = 14 '// Ver1.4 
    Public Const MF_KEY_VERSION_15 As Integer = 15 '// Ver1.5
    Public Const MF_KEY_VERSION_17 As Integer = 17 '// Ver1.7 
    Public Const MF_KEY_VERSION_20 As Integer = 20 '// Ver2.0
    Public Const MF_KEY_VERSION_30 As Integer = 30 '// Ver3.0

    Public Structure MF_INITIAL_DATA
        Dim nKeyVersion As Integer
        Dim lpszTrunkDLL As String
    End Structure

    '//* mfCheckDaysEx *//
    Public Const MF_GET_DAYS As Integer = 1
    Public Const MF_CHECK_DAYS As Integer = 2

    '//* mfReadCodeEx & mfWriteCodeEx *//
    Public Const MF_ERR_LOAD As Integer = -101
    Public Const MF_ERR_SYSTEM As Integer = -102
    Public Const MF_ERR_CRC As Integer = -103
    Public Const MF_ERR_MEMORY As Integer = -104
    Public Const MF_ERR_FILE As Integer = -105
    Public Const MF_ERR_DATA As Integer = -106
    Public Const MF_FIRST_TIME As Integer = 100

    '//* mfSetRegValue & mfGetRegValue & mfGetRegValueSize *//
    Public Const MF_KEY_ROOT As Integer = 1
    Public Const MF_KEY_CURRENT_CONFIG As Integer = 2
    Public Const MF_KEY_CURRENT_USER As Integer = 3
    Public Const MF_KEY_LOCAL_MACHINE As Integer = 4
    Public Const MF_KEY_USER As Integer = 5

    Public Const MF_REG_TYPE_SZ As Integer = 1
    Public Const MF_REG_TYPE_BINARY As Integer = 3

    '// ＤＬＬ 設定
    Public Declare Function mfInitialize Lib "mmgic3f.dll" (ByRef lpInitialData As MF_INITIAL_DATA) As Integer

    '// 認証機能
    Public Declare Function mfCheckDaysEx Lib "mmgic3f.dll" (ByVal nFunction As Integer, ByRef lpTime As MF_TIME, ByRef lpIdentity As MF_IDENTITY_KV13) As Integer
    Public Declare Function mfCheckDaysEx Lib "mmgic3f.dll" (ByVal nFunction As Integer, ByRef lpTime As MF_TIME, ByRef lpIdentity As MF_IDENTITY_KV17) As Integer
    Public Declare Function mfCheckKeyEx Lib "mmgic3f.dll" (ByVal nFigure As Integer, ByRef lpIdentity As MF_IDENTITY_KV13, ByVal szProductKey As String) As Integer
    Public Declare Function mfCheckKeyEx Lib "mmgic3f.dll" (ByVal nFigure As Integer, ByRef lpIdentity As MF_IDENTITY_KV17, ByVal szProductKey As String) As Integer
    Public Declare Function mfMakeProductKeyEx Lib "mmgic3f.dll" (ByVal nFigure As Integer, ByVal szValidationCode() As Byte, ByRef lpIdentity As MF_IDENTITY_KV13, ByVal szProductKey As String) As Integer
    Public Declare Function mfMakeProductKeyEx Lib "mmgic3f.dll" (ByVal nFigure As Integer, ByVal szValidationCode() As Byte, ByRef lpIdentity As MF_IDENTITY_KV17, ByVal szProductKey As String) As Integer
    Public Declare Function mfMakeValidationCodeEx Lib "mmgic3f.dll" (ByVal szProductKey As String, ByRef lpIdentity As MF_IDENTITY_KV13, ByVal szValidationCode() As Byte) As Integer
    Public Declare Function mfMakeValidationCodeEx Lib "mmgic3f.dll" (ByVal szProductKey As String, ByRef lpIdentity As MF_IDENTITY_KV17, ByVal szValidationCode() As Byte) As Integer
    Public Declare Function mfReadCodeEx Lib "mmgic3f.dll" (ByVal szValidationCode() As Byte, ByRef lpTime As MF_TIME) As Integer
    Public Declare Function mfWriteCodeEx Lib "mmgic3f.dll" (ByVal szValidationCode() As Byte, ByRef lpTime As MF_TIME) As Integer
    Public Declare Function mfShowInputBox Lib "mmgic3f.dll" (ByVal pszTitle As String, ByVal pszMsg As String, ByVal nFigure As Integer, ByVal pszProductKey As String) As Integer

    '// その他
    Public Declare Function mfSetRegValue Lib "mmgic3f.dll" (ByVal nKey As Integer, ByVal lpszSubKey As String, ByVal lpszName As String, ByVal dwType As Integer, ByVal dwSize As Integer, ByRef lpData() As Byte) As Integer
    Public Declare Function mfGetRegValue Lib "mmgic3f.dll" (ByVal nKey As Integer, ByVal lpszSubKey As String, ByVal lpszName As String, ByVal dwType As Integer, ByVal dwSize As Integer, ByRef lpData() As Byte) As Integer
    Public Declare Function mfGetRegValueSize Lib "mmgic3f.dll" (ByVal nKey As Integer, ByVal lpszSubKey As String, ByVal lpszName As String, ByVal dwType As Integer) As Integer
    Public Declare Function mfGetFileVersion Lib "mmgic3f.dll" (ByVal lpszFile As String, ByRef lpdwMajor As Integer, ByRef lpdwMinor As Integer, ByRef lpdwRevision As Integer, ByRef lpdwBild As Integer) As Integer

End Module
